#pragma once
// MESSAGE CAP_STATUS PACKING

#define MAVLINK_MSG_ID_CAP_STATUS 15000


typedef struct __mavlink_cap_status_t {
 uint32_t primary_status; /*<  1-parachute, 2-home init, 3-landed, 4-speed override, 5-altitude ovveride, 6-battery low, 7-battery critical, 8-battery emergency, 9-battery parachute pop, 10-failsafe GPS loss, 11-failsafe data link loss, 12-failsafe mission, 13-failsafe offboard loss, 14-failsafe loss of control, 15-failsafe_min_agl, 16 - reserved, 17 - terrain failsafe enabled, 18 - altitude override type, 19 - speed override type, 20 - gimbal extended, 21 - CAP lights, 22 - Position lights, 23 - IR lights, 24 - Strobo lights, 25 - underspeed, 26 - telemetry 2 control enabled, [0, 27-32]: reserved*/
 uint32_t secondary_status; /*<  Reserved*/
 float speed_override_value; /*<  Speed override value*/
 uint32_t flightplan_hash; /*<  Flightplan hash*/
 float eph; /*<  Standard deviation of horizontal position error, (metres)*/
 float epv; /*<  Standard deviation of vertical position error, (metres)*/
 float loiter_radius; /*<  Current loiter radius*/
 float time_to_home; /*<  Time to home in seconds*/
 float max_distance_from_home; /*<  Max distance from home in meters*/
 float reserved2; /*<  reserved2*/
 float reserved3; /*<  reserved3*/
 float reserved4; /*<  reserved4*/
 float reserved5; /*<  reserved5*/
 uint16_t air_time; /*<  Time since take-off*/
 int16_t altitude_override_value; /*<  Altutde override value*/
 uint16_t flightplan_items_count; /*<  Flightplan Items Count*/
} mavlink_cap_status_t;

#define MAVLINK_MSG_ID_CAP_STATUS_LEN 58
#define MAVLINK_MSG_ID_CAP_STATUS_MIN_LEN 58
#define MAVLINK_MSG_ID_15000_LEN 58
#define MAVLINK_MSG_ID_15000_MIN_LEN 58

#define MAVLINK_MSG_ID_CAP_STATUS_CRC 225
#define MAVLINK_MSG_ID_15000_CRC 225



#if MAVLINK_COMMAND_24BIT
#define MAVLINK_MESSAGE_INFO_CAP_STATUS { \
    15000, \
    "CAP_STATUS", \
    16, \
    {  { "air_time", NULL, MAVLINK_TYPE_UINT16_T, 0, 52, offsetof(mavlink_cap_status_t, air_time) }, \
         { "primary_status", NULL, MAVLINK_TYPE_UINT32_T, 0, 0, offsetof(mavlink_cap_status_t, primary_status) }, \
         { "secondary_status", NULL, MAVLINK_TYPE_UINT32_T, 0, 4, offsetof(mavlink_cap_status_t, secondary_status) }, \
         { "altitude_override_value", NULL, MAVLINK_TYPE_INT16_T, 0, 54, offsetof(mavlink_cap_status_t, altitude_override_value) }, \
         { "speed_override_value", NULL, MAVLINK_TYPE_FLOAT, 0, 8, offsetof(mavlink_cap_status_t, speed_override_value) }, \
         { "flightplan_hash", NULL, MAVLINK_TYPE_UINT32_T, 0, 12, offsetof(mavlink_cap_status_t, flightplan_hash) }, \
         { "flightplan_items_count", NULL, MAVLINK_TYPE_UINT16_T, 0, 56, offsetof(mavlink_cap_status_t, flightplan_items_count) }, \
         { "eph", NULL, MAVLINK_TYPE_FLOAT, 0, 16, offsetof(mavlink_cap_status_t, eph) }, \
         { "epv", NULL, MAVLINK_TYPE_FLOAT, 0, 20, offsetof(mavlink_cap_status_t, epv) }, \
         { "loiter_radius", NULL, MAVLINK_TYPE_FLOAT, 0, 24, offsetof(mavlink_cap_status_t, loiter_radius) }, \
         { "time_to_home", NULL, MAVLINK_TYPE_FLOAT, 0, 28, offsetof(mavlink_cap_status_t, time_to_home) }, \
         { "max_distance_from_home", NULL, MAVLINK_TYPE_FLOAT, 0, 32, offsetof(mavlink_cap_status_t, max_distance_from_home) }, \
         { "reserved2", NULL, MAVLINK_TYPE_FLOAT, 0, 36, offsetof(mavlink_cap_status_t, reserved2) }, \
         { "reserved3", NULL, MAVLINK_TYPE_FLOAT, 0, 40, offsetof(mavlink_cap_status_t, reserved3) }, \
         { "reserved4", NULL, MAVLINK_TYPE_FLOAT, 0, 44, offsetof(mavlink_cap_status_t, reserved4) }, \
         { "reserved5", NULL, MAVLINK_TYPE_FLOAT, 0, 48, offsetof(mavlink_cap_status_t, reserved5) }, \
         } \
}
#else
#define MAVLINK_MESSAGE_INFO_CAP_STATUS { \
    "CAP_STATUS", \
    16, \
    {  { "air_time", NULL, MAVLINK_TYPE_UINT16_T, 0, 52, offsetof(mavlink_cap_status_t, air_time) }, \
         { "primary_status", NULL, MAVLINK_TYPE_UINT32_T, 0, 0, offsetof(mavlink_cap_status_t, primary_status) }, \
         { "secondary_status", NULL, MAVLINK_TYPE_UINT32_T, 0, 4, offsetof(mavlink_cap_status_t, secondary_status) }, \
         { "altitude_override_value", NULL, MAVLINK_TYPE_INT16_T, 0, 54, offsetof(mavlink_cap_status_t, altitude_override_value) }, \
         { "speed_override_value", NULL, MAVLINK_TYPE_FLOAT, 0, 8, offsetof(mavlink_cap_status_t, speed_override_value) }, \
         { "flightplan_hash", NULL, MAVLINK_TYPE_UINT32_T, 0, 12, offsetof(mavlink_cap_status_t, flightplan_hash) }, \
         { "flightplan_items_count", NULL, MAVLINK_TYPE_UINT16_T, 0, 56, offsetof(mavlink_cap_status_t, flightplan_items_count) }, \
         { "eph", NULL, MAVLINK_TYPE_FLOAT, 0, 16, offsetof(mavlink_cap_status_t, eph) }, \
         { "epv", NULL, MAVLINK_TYPE_FLOAT, 0, 20, offsetof(mavlink_cap_status_t, epv) }, \
         { "loiter_radius", NULL, MAVLINK_TYPE_FLOAT, 0, 24, offsetof(mavlink_cap_status_t, loiter_radius) }, \
         { "time_to_home", NULL, MAVLINK_TYPE_FLOAT, 0, 28, offsetof(mavlink_cap_status_t, time_to_home) }, \
         { "max_distance_from_home", NULL, MAVLINK_TYPE_FLOAT, 0, 32, offsetof(mavlink_cap_status_t, max_distance_from_home) }, \
         { "reserved2", NULL, MAVLINK_TYPE_FLOAT, 0, 36, offsetof(mavlink_cap_status_t, reserved2) }, \
         { "reserved3", NULL, MAVLINK_TYPE_FLOAT, 0, 40, offsetof(mavlink_cap_status_t, reserved3) }, \
         { "reserved4", NULL, MAVLINK_TYPE_FLOAT, 0, 44, offsetof(mavlink_cap_status_t, reserved4) }, \
         { "reserved5", NULL, MAVLINK_TYPE_FLOAT, 0, 48, offsetof(mavlink_cap_status_t, reserved5) }, \
         } \
}
#endif

/**
 * @brief Pack a cap_status message
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param msg The MAVLink message to compress the data into
 *
 * @param air_time  Time since take-off
 * @param primary_status  1-parachute, 2-home init, 3-landed, 4-speed override, 5-altitude ovveride, 6-battery low, 7-battery critical, 8-battery emergency, 9-battery parachute pop, 10-failsafe GPS loss, 11-failsafe data link loss, 12-failsafe mission, 13-failsafe offboard loss, 14-failsafe loss of control, 15-failsafe_min_agl, 16 - reserved, 17 - terrain failsafe enabled, 18 - altitude override type, 19 - speed override type, 20 - gimbal extended, 21 - CAP lights, 22 - Position lights, 23 - IR lights, 24 - Strobo lights, 25 - underspeed, 26 - telemetry 2 control enabled, [0, 27-32]: reserved
 * @param secondary_status  Reserved
 * @param altitude_override_value  Altutde override value
 * @param speed_override_value  Speed override value
 * @param flightplan_hash  Flightplan hash
 * @param flightplan_items_count  Flightplan Items Count
 * @param eph  Standard deviation of horizontal position error, (metres)
 * @param epv  Standard deviation of vertical position error, (metres)
 * @param loiter_radius  Current loiter radius
 * @param time_to_home  Time to home in seconds
 * @param max_distance_from_home  Max distance from home in meters
 * @param reserved2  reserved2
 * @param reserved3  reserved3
 * @param reserved4  reserved4
 * @param reserved5  reserved5
 * @return length of the message in bytes (excluding serial stream start sign)
 */
static inline uint16_t mavlink_msg_cap_status_pack(uint8_t system_id, uint8_t component_id, mavlink_message_t* msg,
                               uint16_t air_time, uint32_t primary_status, uint32_t secondary_status, int16_t altitude_override_value, float speed_override_value, uint32_t flightplan_hash, uint16_t flightplan_items_count, float eph, float epv, float loiter_radius, float time_to_home, float max_distance_from_home, float reserved2, float reserved3, float reserved4, float reserved5)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    char buf[MAVLINK_MSG_ID_CAP_STATUS_LEN];
    _mav_put_uint32_t(buf, 0, primary_status);
    _mav_put_uint32_t(buf, 4, secondary_status);
    _mav_put_float(buf, 8, speed_override_value);
    _mav_put_uint32_t(buf, 12, flightplan_hash);
    _mav_put_float(buf, 16, eph);
    _mav_put_float(buf, 20, epv);
    _mav_put_float(buf, 24, loiter_radius);
    _mav_put_float(buf, 28, time_to_home);
    _mav_put_float(buf, 32, max_distance_from_home);
    _mav_put_float(buf, 36, reserved2);
    _mav_put_float(buf, 40, reserved3);
    _mav_put_float(buf, 44, reserved4);
    _mav_put_float(buf, 48, reserved5);
    _mav_put_uint16_t(buf, 52, air_time);
    _mav_put_int16_t(buf, 54, altitude_override_value);
    _mav_put_uint16_t(buf, 56, flightplan_items_count);

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), buf, MAVLINK_MSG_ID_CAP_STATUS_LEN);
#else
    mavlink_cap_status_t packet;
    packet.primary_status = primary_status;
    packet.secondary_status = secondary_status;
    packet.speed_override_value = speed_override_value;
    packet.flightplan_hash = flightplan_hash;
    packet.eph = eph;
    packet.epv = epv;
    packet.loiter_radius = loiter_radius;
    packet.time_to_home = time_to_home;
    packet.max_distance_from_home = max_distance_from_home;
    packet.reserved2 = reserved2;
    packet.reserved3 = reserved3;
    packet.reserved4 = reserved4;
    packet.reserved5 = reserved5;
    packet.air_time = air_time;
    packet.altitude_override_value = altitude_override_value;
    packet.flightplan_items_count = flightplan_items_count;

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), &packet, MAVLINK_MSG_ID_CAP_STATUS_LEN);
#endif

    msg->msgid = MAVLINK_MSG_ID_CAP_STATUS;
    return mavlink_finalize_message(msg, system_id, component_id, MAVLINK_MSG_ID_CAP_STATUS_MIN_LEN, MAVLINK_MSG_ID_CAP_STATUS_LEN, MAVLINK_MSG_ID_CAP_STATUS_CRC);
}

/**
 * @brief Pack a cap_status message on a channel
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param chan The MAVLink channel this message will be sent over
 * @param msg The MAVLink message to compress the data into
 * @param air_time  Time since take-off
 * @param primary_status  1-parachute, 2-home init, 3-landed, 4-speed override, 5-altitude ovveride, 6-battery low, 7-battery critical, 8-battery emergency, 9-battery parachute pop, 10-failsafe GPS loss, 11-failsafe data link loss, 12-failsafe mission, 13-failsafe offboard loss, 14-failsafe loss of control, 15-failsafe_min_agl, 16 - reserved, 17 - terrain failsafe enabled, 18 - altitude override type, 19 - speed override type, 20 - gimbal extended, 21 - CAP lights, 22 - Position lights, 23 - IR lights, 24 - Strobo lights, 25 - underspeed, 26 - telemetry 2 control enabled, [0, 27-32]: reserved
 * @param secondary_status  Reserved
 * @param altitude_override_value  Altutde override value
 * @param speed_override_value  Speed override value
 * @param flightplan_hash  Flightplan hash
 * @param flightplan_items_count  Flightplan Items Count
 * @param eph  Standard deviation of horizontal position error, (metres)
 * @param epv  Standard deviation of vertical position error, (metres)
 * @param loiter_radius  Current loiter radius
 * @param time_to_home  Time to home in seconds
 * @param max_distance_from_home  Max distance from home in meters
 * @param reserved2  reserved2
 * @param reserved3  reserved3
 * @param reserved4  reserved4
 * @param reserved5  reserved5
 * @return length of the message in bytes (excluding serial stream start sign)
 */
static inline uint16_t mavlink_msg_cap_status_pack_chan(uint8_t system_id, uint8_t component_id, uint8_t chan,
                               mavlink_message_t* msg,
                                   uint16_t air_time,uint32_t primary_status,uint32_t secondary_status,int16_t altitude_override_value,float speed_override_value,uint32_t flightplan_hash,uint16_t flightplan_items_count,float eph,float epv,float loiter_radius,float time_to_home,float max_distance_from_home,float reserved2,float reserved3,float reserved4,float reserved5)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    char buf[MAVLINK_MSG_ID_CAP_STATUS_LEN];
    _mav_put_uint32_t(buf, 0, primary_status);
    _mav_put_uint32_t(buf, 4, secondary_status);
    _mav_put_float(buf, 8, speed_override_value);
    _mav_put_uint32_t(buf, 12, flightplan_hash);
    _mav_put_float(buf, 16, eph);
    _mav_put_float(buf, 20, epv);
    _mav_put_float(buf, 24, loiter_radius);
    _mav_put_float(buf, 28, time_to_home);
    _mav_put_float(buf, 32, max_distance_from_home);
    _mav_put_float(buf, 36, reserved2);
    _mav_put_float(buf, 40, reserved3);
    _mav_put_float(buf, 44, reserved4);
    _mav_put_float(buf, 48, reserved5);
    _mav_put_uint16_t(buf, 52, air_time);
    _mav_put_int16_t(buf, 54, altitude_override_value);
    _mav_put_uint16_t(buf, 56, flightplan_items_count);

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), buf, MAVLINK_MSG_ID_CAP_STATUS_LEN);
#else
    mavlink_cap_status_t packet;
    packet.primary_status = primary_status;
    packet.secondary_status = secondary_status;
    packet.speed_override_value = speed_override_value;
    packet.flightplan_hash = flightplan_hash;
    packet.eph = eph;
    packet.epv = epv;
    packet.loiter_radius = loiter_radius;
    packet.time_to_home = time_to_home;
    packet.max_distance_from_home = max_distance_from_home;
    packet.reserved2 = reserved2;
    packet.reserved3 = reserved3;
    packet.reserved4 = reserved4;
    packet.reserved5 = reserved5;
    packet.air_time = air_time;
    packet.altitude_override_value = altitude_override_value;
    packet.flightplan_items_count = flightplan_items_count;

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), &packet, MAVLINK_MSG_ID_CAP_STATUS_LEN);
#endif

    msg->msgid = MAVLINK_MSG_ID_CAP_STATUS;
    return mavlink_finalize_message_chan(msg, system_id, component_id, chan, MAVLINK_MSG_ID_CAP_STATUS_MIN_LEN, MAVLINK_MSG_ID_CAP_STATUS_LEN, MAVLINK_MSG_ID_CAP_STATUS_CRC);
}

/**
 * @brief Encode a cap_status struct
 *
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param msg The MAVLink message to compress the data into
 * @param cap_status C-struct to read the message contents from
 */
static inline uint16_t mavlink_msg_cap_status_encode(uint8_t system_id, uint8_t component_id, mavlink_message_t* msg, const mavlink_cap_status_t* cap_status)
{
    return mavlink_msg_cap_status_pack(system_id, component_id, msg, cap_status->air_time, cap_status->primary_status, cap_status->secondary_status, cap_status->altitude_override_value, cap_status->speed_override_value, cap_status->flightplan_hash, cap_status->flightplan_items_count, cap_status->eph, cap_status->epv, cap_status->loiter_radius, cap_status->time_to_home, cap_status->max_distance_from_home, cap_status->reserved2, cap_status->reserved3, cap_status->reserved4, cap_status->reserved5);
}

/**
 * @brief Encode a cap_status struct on a channel
 *
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param chan The MAVLink channel this message will be sent over
 * @param msg The MAVLink message to compress the data into
 * @param cap_status C-struct to read the message contents from
 */
static inline uint16_t mavlink_msg_cap_status_encode_chan(uint8_t system_id, uint8_t component_id, uint8_t chan, mavlink_message_t* msg, const mavlink_cap_status_t* cap_status)
{
    return mavlink_msg_cap_status_pack_chan(system_id, component_id, chan, msg, cap_status->air_time, cap_status->primary_status, cap_status->secondary_status, cap_status->altitude_override_value, cap_status->speed_override_value, cap_status->flightplan_hash, cap_status->flightplan_items_count, cap_status->eph, cap_status->epv, cap_status->loiter_radius, cap_status->time_to_home, cap_status->max_distance_from_home, cap_status->reserved2, cap_status->reserved3, cap_status->reserved4, cap_status->reserved5);
}

/**
 * @brief Send a cap_status message
 * @param chan MAVLink channel to send the message
 *
 * @param air_time  Time since take-off
 * @param primary_status  1-parachute, 2-home init, 3-landed, 4-speed override, 5-altitude ovveride, 6-battery low, 7-battery critical, 8-battery emergency, 9-battery parachute pop, 10-failsafe GPS loss, 11-failsafe data link loss, 12-failsafe mission, 13-failsafe offboard loss, 14-failsafe loss of control, 15-failsafe_min_agl, 16 - reserved, 17 - terrain failsafe enabled, 18 - altitude override type, 19 - speed override type, 20 - gimbal extended, 21 - CAP lights, 22 - Position lights, 23 - IR lights, 24 - Strobo lights, 25 - underspeed, 26 - telemetry 2 control enabled, [0, 27-32]: reserved
 * @param secondary_status  Reserved
 * @param altitude_override_value  Altutde override value
 * @param speed_override_value  Speed override value
 * @param flightplan_hash  Flightplan hash
 * @param flightplan_items_count  Flightplan Items Count
 * @param eph  Standard deviation of horizontal position error, (metres)
 * @param epv  Standard deviation of vertical position error, (metres)
 * @param loiter_radius  Current loiter radius
 * @param time_to_home  Time to home in seconds
 * @param max_distance_from_home  Max distance from home in meters
 * @param reserved2  reserved2
 * @param reserved3  reserved3
 * @param reserved4  reserved4
 * @param reserved5  reserved5
 */
#ifdef MAVLINK_USE_CONVENIENCE_FUNCTIONS

static inline void mavlink_msg_cap_status_send(mavlink_channel_t chan, uint16_t air_time, uint32_t primary_status, uint32_t secondary_status, int16_t altitude_override_value, float speed_override_value, uint32_t flightplan_hash, uint16_t flightplan_items_count, float eph, float epv, float loiter_radius, float time_to_home, float max_distance_from_home, float reserved2, float reserved3, float reserved4, float reserved5)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    char buf[MAVLINK_MSG_ID_CAP_STATUS_LEN];
    _mav_put_uint32_t(buf, 0, primary_status);
    _mav_put_uint32_t(buf, 4, secondary_status);
    _mav_put_float(buf, 8, speed_override_value);
    _mav_put_uint32_t(buf, 12, flightplan_hash);
    _mav_put_float(buf, 16, eph);
    _mav_put_float(buf, 20, epv);
    _mav_put_float(buf, 24, loiter_radius);
    _mav_put_float(buf, 28, time_to_home);
    _mav_put_float(buf, 32, max_distance_from_home);
    _mav_put_float(buf, 36, reserved2);
    _mav_put_float(buf, 40, reserved3);
    _mav_put_float(buf, 44, reserved4);
    _mav_put_float(buf, 48, reserved5);
    _mav_put_uint16_t(buf, 52, air_time);
    _mav_put_int16_t(buf, 54, altitude_override_value);
    _mav_put_uint16_t(buf, 56, flightplan_items_count);

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_CAP_STATUS, buf, MAVLINK_MSG_ID_CAP_STATUS_MIN_LEN, MAVLINK_MSG_ID_CAP_STATUS_LEN, MAVLINK_MSG_ID_CAP_STATUS_CRC);
#else
    mavlink_cap_status_t packet;
    packet.primary_status = primary_status;
    packet.secondary_status = secondary_status;
    packet.speed_override_value = speed_override_value;
    packet.flightplan_hash = flightplan_hash;
    packet.eph = eph;
    packet.epv = epv;
    packet.loiter_radius = loiter_radius;
    packet.time_to_home = time_to_home;
    packet.max_distance_from_home = max_distance_from_home;
    packet.reserved2 = reserved2;
    packet.reserved3 = reserved3;
    packet.reserved4 = reserved4;
    packet.reserved5 = reserved5;
    packet.air_time = air_time;
    packet.altitude_override_value = altitude_override_value;
    packet.flightplan_items_count = flightplan_items_count;

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_CAP_STATUS, (const char *)&packet, MAVLINK_MSG_ID_CAP_STATUS_MIN_LEN, MAVLINK_MSG_ID_CAP_STATUS_LEN, MAVLINK_MSG_ID_CAP_STATUS_CRC);
#endif
}

/**
 * @brief Send a cap_status message
 * @param chan MAVLink channel to send the message
 * @param struct The MAVLink struct to serialize
 */
static inline void mavlink_msg_cap_status_send_struct(mavlink_channel_t chan, const mavlink_cap_status_t* cap_status)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    mavlink_msg_cap_status_send(chan, cap_status->air_time, cap_status->primary_status, cap_status->secondary_status, cap_status->altitude_override_value, cap_status->speed_override_value, cap_status->flightplan_hash, cap_status->flightplan_items_count, cap_status->eph, cap_status->epv, cap_status->loiter_radius, cap_status->time_to_home, cap_status->max_distance_from_home, cap_status->reserved2, cap_status->reserved3, cap_status->reserved4, cap_status->reserved5);
#else
    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_CAP_STATUS, (const char *)cap_status, MAVLINK_MSG_ID_CAP_STATUS_MIN_LEN, MAVLINK_MSG_ID_CAP_STATUS_LEN, MAVLINK_MSG_ID_CAP_STATUS_CRC);
#endif
}

#if MAVLINK_MSG_ID_CAP_STATUS_LEN <= MAVLINK_MAX_PAYLOAD_LEN
/*
  This variant of _send() can be used to save stack space by re-using
  memory from the receive buffer.  The caller provides a
  mavlink_message_t which is the size of a full mavlink message. This
  is usually the receive buffer for the channel, and allows a reply to an
  incoming message with minimum stack space usage.
 */
static inline void mavlink_msg_cap_status_send_buf(mavlink_message_t *msgbuf, mavlink_channel_t chan,  uint16_t air_time, uint32_t primary_status, uint32_t secondary_status, int16_t altitude_override_value, float speed_override_value, uint32_t flightplan_hash, uint16_t flightplan_items_count, float eph, float epv, float loiter_radius, float time_to_home, float max_distance_from_home, float reserved2, float reserved3, float reserved4, float reserved5)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    char *buf = (char *)msgbuf;
    _mav_put_uint32_t(buf, 0, primary_status);
    _mav_put_uint32_t(buf, 4, secondary_status);
    _mav_put_float(buf, 8, speed_override_value);
    _mav_put_uint32_t(buf, 12, flightplan_hash);
    _mav_put_float(buf, 16, eph);
    _mav_put_float(buf, 20, epv);
    _mav_put_float(buf, 24, loiter_radius);
    _mav_put_float(buf, 28, time_to_home);
    _mav_put_float(buf, 32, max_distance_from_home);
    _mav_put_float(buf, 36, reserved2);
    _mav_put_float(buf, 40, reserved3);
    _mav_put_float(buf, 44, reserved4);
    _mav_put_float(buf, 48, reserved5);
    _mav_put_uint16_t(buf, 52, air_time);
    _mav_put_int16_t(buf, 54, altitude_override_value);
    _mav_put_uint16_t(buf, 56, flightplan_items_count);

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_CAP_STATUS, buf, MAVLINK_MSG_ID_CAP_STATUS_MIN_LEN, MAVLINK_MSG_ID_CAP_STATUS_LEN, MAVLINK_MSG_ID_CAP_STATUS_CRC);
#else
    mavlink_cap_status_t *packet = (mavlink_cap_status_t *)msgbuf;
    packet->primary_status = primary_status;
    packet->secondary_status = secondary_status;
    packet->speed_override_value = speed_override_value;
    packet->flightplan_hash = flightplan_hash;
    packet->eph = eph;
    packet->epv = epv;
    packet->loiter_radius = loiter_radius;
    packet->time_to_home = time_to_home;
    packet->max_distance_from_home = max_distance_from_home;
    packet->reserved2 = reserved2;
    packet->reserved3 = reserved3;
    packet->reserved4 = reserved4;
    packet->reserved5 = reserved5;
    packet->air_time = air_time;
    packet->altitude_override_value = altitude_override_value;
    packet->flightplan_items_count = flightplan_items_count;

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_CAP_STATUS, (const char *)packet, MAVLINK_MSG_ID_CAP_STATUS_MIN_LEN, MAVLINK_MSG_ID_CAP_STATUS_LEN, MAVLINK_MSG_ID_CAP_STATUS_CRC);
#endif
}
#endif

#endif

// MESSAGE CAP_STATUS UNPACKING


/**
 * @brief Get field air_time from cap_status message
 *
 * @return  Time since take-off
 */
static inline uint16_t mavlink_msg_cap_status_get_air_time(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint16_t(msg,  52);
}

/**
 * @brief Get field primary_status from cap_status message
 *
 * @return  1-parachute, 2-home init, 3-landed, 4-speed override, 5-altitude ovveride, 6-battery low, 7-battery critical, 8-battery emergency, 9-battery parachute pop, 10-failsafe GPS loss, 11-failsafe data link loss, 12-failsafe mission, 13-failsafe offboard loss, 14-failsafe loss of control, 15-failsafe_min_agl, 16 - reserved, 17 - terrain failsafe enabled, 18 - altitude override type, 19 - speed override type, 20 - gimbal extended, 21 - CAP lights, 22 - Position lights, 23 - IR lights, 24 - Strobo lights, 25 - underspeed, 26 - telemetry 2 control enabled, [0, 27-32]: reserved
 */
static inline uint32_t mavlink_msg_cap_status_get_primary_status(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint32_t(msg,  0);
}

/**
 * @brief Get field secondary_status from cap_status message
 *
 * @return  Reserved
 */
static inline uint32_t mavlink_msg_cap_status_get_secondary_status(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint32_t(msg,  4);
}

/**
 * @brief Get field altitude_override_value from cap_status message
 *
 * @return  Altutde override value
 */
static inline int16_t mavlink_msg_cap_status_get_altitude_override_value(const mavlink_message_t* msg)
{
    return _MAV_RETURN_int16_t(msg,  54);
}

/**
 * @brief Get field speed_override_value from cap_status message
 *
 * @return  Speed override value
 */
static inline float mavlink_msg_cap_status_get_speed_override_value(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  8);
}

/**
 * @brief Get field flightplan_hash from cap_status message
 *
 * @return  Flightplan hash
 */
static inline uint32_t mavlink_msg_cap_status_get_flightplan_hash(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint32_t(msg,  12);
}

/**
 * @brief Get field flightplan_items_count from cap_status message
 *
 * @return  Flightplan Items Count
 */
static inline uint16_t mavlink_msg_cap_status_get_flightplan_items_count(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint16_t(msg,  56);
}

/**
 * @brief Get field eph from cap_status message
 *
 * @return  Standard deviation of horizontal position error, (metres)
 */
static inline float mavlink_msg_cap_status_get_eph(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  16);
}

/**
 * @brief Get field epv from cap_status message
 *
 * @return  Standard deviation of vertical position error, (metres)
 */
static inline float mavlink_msg_cap_status_get_epv(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  20);
}

/**
 * @brief Get field loiter_radius from cap_status message
 *
 * @return  Current loiter radius
 */
static inline float mavlink_msg_cap_status_get_loiter_radius(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  24);
}

/**
 * @brief Get field time_to_home from cap_status message
 *
 * @return  Time to home in seconds
 */
static inline float mavlink_msg_cap_status_get_time_to_home(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  28);
}

/**
 * @brief Get field max_distance_from_home from cap_status message
 *
 * @return  Max distance from home in meters
 */
static inline float mavlink_msg_cap_status_get_max_distance_from_home(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  32);
}

/**
 * @brief Get field reserved2 from cap_status message
 *
 * @return  reserved2
 */
static inline float mavlink_msg_cap_status_get_reserved2(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  36);
}

/**
 * @brief Get field reserved3 from cap_status message
 *
 * @return  reserved3
 */
static inline float mavlink_msg_cap_status_get_reserved3(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  40);
}

/**
 * @brief Get field reserved4 from cap_status message
 *
 * @return  reserved4
 */
static inline float mavlink_msg_cap_status_get_reserved4(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  44);
}

/**
 * @brief Get field reserved5 from cap_status message
 *
 * @return  reserved5
 */
static inline float mavlink_msg_cap_status_get_reserved5(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  48);
}

/**
 * @brief Decode a cap_status message into a struct
 *
 * @param msg The message to decode
 * @param cap_status C-struct to decode the message contents into
 */
static inline void mavlink_msg_cap_status_decode(const mavlink_message_t* msg, mavlink_cap_status_t* cap_status)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    cap_status->primary_status = mavlink_msg_cap_status_get_primary_status(msg);
    cap_status->secondary_status = mavlink_msg_cap_status_get_secondary_status(msg);
    cap_status->speed_override_value = mavlink_msg_cap_status_get_speed_override_value(msg);
    cap_status->flightplan_hash = mavlink_msg_cap_status_get_flightplan_hash(msg);
    cap_status->eph = mavlink_msg_cap_status_get_eph(msg);
    cap_status->epv = mavlink_msg_cap_status_get_epv(msg);
    cap_status->loiter_radius = mavlink_msg_cap_status_get_loiter_radius(msg);
    cap_status->time_to_home = mavlink_msg_cap_status_get_time_to_home(msg);
    cap_status->max_distance_from_home = mavlink_msg_cap_status_get_max_distance_from_home(msg);
    cap_status->reserved2 = mavlink_msg_cap_status_get_reserved2(msg);
    cap_status->reserved3 = mavlink_msg_cap_status_get_reserved3(msg);
    cap_status->reserved4 = mavlink_msg_cap_status_get_reserved4(msg);
    cap_status->reserved5 = mavlink_msg_cap_status_get_reserved5(msg);
    cap_status->air_time = mavlink_msg_cap_status_get_air_time(msg);
    cap_status->altitude_override_value = mavlink_msg_cap_status_get_altitude_override_value(msg);
    cap_status->flightplan_items_count = mavlink_msg_cap_status_get_flightplan_items_count(msg);
#else
        uint8_t len = msg->len < MAVLINK_MSG_ID_CAP_STATUS_LEN? msg->len : MAVLINK_MSG_ID_CAP_STATUS_LEN;
        memset(cap_status, 0, MAVLINK_MSG_ID_CAP_STATUS_LEN);
    memcpy(cap_status, _MAV_PAYLOAD(msg), len);
#endif
}
