#pragma once
// MESSAGE CAP_STATUS_FREQUENT PACKING

#define MAVLINK_MSG_ID_CAP_STATUS_FREQUENT 15007


typedef struct __mavlink_cap_status_frequent_t {
 uint64_t utc_time; /*<  UTC time reported by the GPS.*/
} mavlink_cap_status_frequent_t;

#define MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_LEN 8
#define MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_MIN_LEN 8
#define MAVLINK_MSG_ID_15007_LEN 8
#define MAVLINK_MSG_ID_15007_MIN_LEN 8

#define MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_CRC 93
#define MAVLINK_MSG_ID_15007_CRC 93



#if MAVLINK_COMMAND_24BIT
#define MAVLINK_MESSAGE_INFO_CAP_STATUS_FREQUENT { \
    15007, \
    "CAP_STATUS_FREQUENT", \
    1, \
    {  { "utc_time", NULL, MAVLINK_TYPE_UINT64_T, 0, 0, offsetof(mavlink_cap_status_frequent_t, utc_time) }, \
         } \
}
#else
#define MAVLINK_MESSAGE_INFO_CAP_STATUS_FREQUENT { \
    "CAP_STATUS_FREQUENT", \
    1, \
    {  { "utc_time", NULL, MAVLINK_TYPE_UINT64_T, 0, 0, offsetof(mavlink_cap_status_frequent_t, utc_time) }, \
         } \
}
#endif

/**
 * @brief Pack a cap_status_frequent message
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param msg The MAVLink message to compress the data into
 *
 * @param utc_time  UTC time reported by the GPS.
 * @return length of the message in bytes (excluding serial stream start sign)
 */
static inline uint16_t mavlink_msg_cap_status_frequent_pack(uint8_t system_id, uint8_t component_id, mavlink_message_t* msg,
                               uint64_t utc_time)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    char buf[MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_LEN];
    _mav_put_uint64_t(buf, 0, utc_time);

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), buf, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_LEN);
#else
    mavlink_cap_status_frequent_t packet;
    packet.utc_time = utc_time;

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), &packet, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_LEN);
#endif

    msg->msgid = MAVLINK_MSG_ID_CAP_STATUS_FREQUENT;
    return mavlink_finalize_message(msg, system_id, component_id, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_MIN_LEN, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_LEN, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_CRC);
}

/**
 * @brief Pack a cap_status_frequent message on a channel
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param chan The MAVLink channel this message will be sent over
 * @param msg The MAVLink message to compress the data into
 * @param utc_time  UTC time reported by the GPS.
 * @return length of the message in bytes (excluding serial stream start sign)
 */
static inline uint16_t mavlink_msg_cap_status_frequent_pack_chan(uint8_t system_id, uint8_t component_id, uint8_t chan,
                               mavlink_message_t* msg,
                                   uint64_t utc_time)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    char buf[MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_LEN];
    _mav_put_uint64_t(buf, 0, utc_time);

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), buf, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_LEN);
#else
    mavlink_cap_status_frequent_t packet;
    packet.utc_time = utc_time;

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), &packet, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_LEN);
#endif

    msg->msgid = MAVLINK_MSG_ID_CAP_STATUS_FREQUENT;
    return mavlink_finalize_message_chan(msg, system_id, component_id, chan, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_MIN_LEN, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_LEN, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_CRC);
}

/**
 * @brief Encode a cap_status_frequent struct
 *
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param msg The MAVLink message to compress the data into
 * @param cap_status_frequent C-struct to read the message contents from
 */
static inline uint16_t mavlink_msg_cap_status_frequent_encode(uint8_t system_id, uint8_t component_id, mavlink_message_t* msg, const mavlink_cap_status_frequent_t* cap_status_frequent)
{
    return mavlink_msg_cap_status_frequent_pack(system_id, component_id, msg, cap_status_frequent->utc_time);
}

/**
 * @brief Encode a cap_status_frequent struct on a channel
 *
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param chan The MAVLink channel this message will be sent over
 * @param msg The MAVLink message to compress the data into
 * @param cap_status_frequent C-struct to read the message contents from
 */
static inline uint16_t mavlink_msg_cap_status_frequent_encode_chan(uint8_t system_id, uint8_t component_id, uint8_t chan, mavlink_message_t* msg, const mavlink_cap_status_frequent_t* cap_status_frequent)
{
    return mavlink_msg_cap_status_frequent_pack_chan(system_id, component_id, chan, msg, cap_status_frequent->utc_time);
}

/**
 * @brief Send a cap_status_frequent message
 * @param chan MAVLink channel to send the message
 *
 * @param utc_time  UTC time reported by the GPS.
 */
#ifdef MAVLINK_USE_CONVENIENCE_FUNCTIONS

static inline void mavlink_msg_cap_status_frequent_send(mavlink_channel_t chan, uint64_t utc_time)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    char buf[MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_LEN];
    _mav_put_uint64_t(buf, 0, utc_time);

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT, buf, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_MIN_LEN, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_LEN, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_CRC);
#else
    mavlink_cap_status_frequent_t packet;
    packet.utc_time = utc_time;

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT, (const char *)&packet, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_MIN_LEN, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_LEN, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_CRC);
#endif
}

/**
 * @brief Send a cap_status_frequent message
 * @param chan MAVLink channel to send the message
 * @param struct The MAVLink struct to serialize
 */
static inline void mavlink_msg_cap_status_frequent_send_struct(mavlink_channel_t chan, const mavlink_cap_status_frequent_t* cap_status_frequent)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    mavlink_msg_cap_status_frequent_send(chan, cap_status_frequent->utc_time);
#else
    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT, (const char *)cap_status_frequent, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_MIN_LEN, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_LEN, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_CRC);
#endif
}

#if MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_LEN <= MAVLINK_MAX_PAYLOAD_LEN
/*
  This variant of _send() can be used to save stack space by re-using
  memory from the receive buffer.  The caller provides a
  mavlink_message_t which is the size of a full mavlink message. This
  is usually the receive buffer for the channel, and allows a reply to an
  incoming message with minimum stack space usage.
 */
static inline void mavlink_msg_cap_status_frequent_send_buf(mavlink_message_t *msgbuf, mavlink_channel_t chan,  uint64_t utc_time)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    char *buf = (char *)msgbuf;
    _mav_put_uint64_t(buf, 0, utc_time);

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT, buf, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_MIN_LEN, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_LEN, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_CRC);
#else
    mavlink_cap_status_frequent_t *packet = (mavlink_cap_status_frequent_t *)msgbuf;
    packet->utc_time = utc_time;

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT, (const char *)packet, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_MIN_LEN, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_LEN, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_CRC);
#endif
}
#endif

#endif

// MESSAGE CAP_STATUS_FREQUENT UNPACKING


/**
 * @brief Get field utc_time from cap_status_frequent message
 *
 * @return  UTC time reported by the GPS.
 */
static inline uint64_t mavlink_msg_cap_status_frequent_get_utc_time(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint64_t(msg,  0);
}

/**
 * @brief Decode a cap_status_frequent message into a struct
 *
 * @param msg The message to decode
 * @param cap_status_frequent C-struct to decode the message contents into
 */
static inline void mavlink_msg_cap_status_frequent_decode(const mavlink_message_t* msg, mavlink_cap_status_frequent_t* cap_status_frequent)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    cap_status_frequent->utc_time = mavlink_msg_cap_status_frequent_get_utc_time(msg);
#else
        uint8_t len = msg->len < MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_LEN? msg->len : MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_LEN;
        memset(cap_status_frequent, 0, MAVLINK_MSG_ID_CAP_STATUS_FREQUENT_LEN);
    memcpy(cap_status_frequent, _MAV_PAYLOAD(msg), len);
#endif
}
