// MESSAGE CAP_STATUS_FREQUENT support class

#pragma once

namespace mavlink {
namespace common {
namespace msg {

/**
 * @brief CAP_STATUS_FREQUENT message
 *
 * Properties of the CAP system that need to be reported more frequently then CAP_STATUS.
 */
struct CAP_STATUS_FREQUENT : mavlink::Message {
    static constexpr msgid_t MSG_ID = 15007;
    static constexpr size_t LENGTH = 8;
    static constexpr size_t MIN_LENGTH = 8;
    static constexpr uint8_t CRC_EXTRA = 93;
    static constexpr auto NAME = "CAP_STATUS_FREQUENT";


    uint64_t utc_time; /*<  UTC time reported by the GPS. */


    inline std::string get_name(void) const override
    {
            return NAME;
    }

    inline Info get_message_info(void) const override
    {
            return { MSG_ID, LENGTH, MIN_LENGTH, CRC_EXTRA };
    }

    inline std::string to_yaml(void) const override
    {
        std::stringstream ss;

        ss << NAME << ":" << std::endl;
        ss << "  utc_time: " << utc_time << std::endl;

        return ss.str();
    }

    inline void serialize(mavlink::MsgMap &map) const override
    {
        map.reset(MSG_ID, LENGTH);

        map << utc_time;                      // offset: 0
    }

    inline void deserialize(mavlink::MsgMap &map) override
    {
        map >> utc_time;                      // offset: 0
    }
};

} // namespace msg
} // namespace common
} // namespace mavlink
