#pragma once
// MESSAGE MISSION_COUNT_CAP PACKING

#define MAVLINK_MSG_ID_MISSION_COUNT_CAP 15008


typedef struct __mavlink_mission_count_cap_t {
 uint16_t count; /*<  Number of mission items in the sequence*/
 uint8_t target_system; /*<  System ID*/
 uint8_t target_component; /*<  Component ID*/
 uint8_t mission_type; /*<  Mission type.*/
} mavlink_mission_count_cap_t;

#define MAVLINK_MSG_ID_MISSION_COUNT_CAP_LEN 5
#define MAVLINK_MSG_ID_MISSION_COUNT_CAP_MIN_LEN 4
#define MAVLINK_MSG_ID_15008_LEN 5
#define MAVLINK_MSG_ID_15008_MIN_LEN 4

#define MAVLINK_MSG_ID_MISSION_COUNT_CAP_CRC 28
#define MAVLINK_MSG_ID_15008_CRC 28



#if MAVLINK_COMMAND_24BIT
#define MAVLINK_MESSAGE_INFO_MISSION_COUNT_CAP { \
    15008, \
    "MISSION_COUNT_CAP", \
    4, \
    {  { "target_system", NULL, MAVLINK_TYPE_UINT8_T, 0, 2, offsetof(mavlink_mission_count_cap_t, target_system) }, \
         { "target_component", NULL, MAVLINK_TYPE_UINT8_T, 0, 3, offsetof(mavlink_mission_count_cap_t, target_component) }, \
         { "count", NULL, MAVLINK_TYPE_UINT16_T, 0, 0, offsetof(mavlink_mission_count_cap_t, count) }, \
         { "mission_type", NULL, MAVLINK_TYPE_UINT8_T, 0, 4, offsetof(mavlink_mission_count_cap_t, mission_type) }, \
         } \
}
#else
#define MAVLINK_MESSAGE_INFO_MISSION_COUNT_CAP { \
    "MISSION_COUNT_CAP", \
    4, \
    {  { "target_system", NULL, MAVLINK_TYPE_UINT8_T, 0, 2, offsetof(mavlink_mission_count_cap_t, target_system) }, \
         { "target_component", NULL, MAVLINK_TYPE_UINT8_T, 0, 3, offsetof(mavlink_mission_count_cap_t, target_component) }, \
         { "count", NULL, MAVLINK_TYPE_UINT16_T, 0, 0, offsetof(mavlink_mission_count_cap_t, count) }, \
         { "mission_type", NULL, MAVLINK_TYPE_UINT8_T, 0, 4, offsetof(mavlink_mission_count_cap_t, mission_type) }, \
         } \
}
#endif

/**
 * @brief Pack a mission_count_cap message
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param msg The MAVLink message to compress the data into
 *
 * @param target_system  System ID
 * @param target_component  Component ID
 * @param count  Number of mission items in the sequence
 * @param mission_type  Mission type.
 * @return length of the message in bytes (excluding serial stream start sign)
 */
static inline uint16_t mavlink_msg_mission_count_cap_pack(uint8_t system_id, uint8_t component_id, mavlink_message_t* msg,
                               uint8_t target_system, uint8_t target_component, uint16_t count, uint8_t mission_type)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    char buf[MAVLINK_MSG_ID_MISSION_COUNT_CAP_LEN];
    _mav_put_uint16_t(buf, 0, count);
    _mav_put_uint8_t(buf, 2, target_system);
    _mav_put_uint8_t(buf, 3, target_component);
    _mav_put_uint8_t(buf, 4, mission_type);

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), buf, MAVLINK_MSG_ID_MISSION_COUNT_CAP_LEN);
#else
    mavlink_mission_count_cap_t packet;
    packet.count = count;
    packet.target_system = target_system;
    packet.target_component = target_component;
    packet.mission_type = mission_type;

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), &packet, MAVLINK_MSG_ID_MISSION_COUNT_CAP_LEN);
#endif

    msg->msgid = MAVLINK_MSG_ID_MISSION_COUNT_CAP;
    return mavlink_finalize_message(msg, system_id, component_id, MAVLINK_MSG_ID_MISSION_COUNT_CAP_MIN_LEN, MAVLINK_MSG_ID_MISSION_COUNT_CAP_LEN, MAVLINK_MSG_ID_MISSION_COUNT_CAP_CRC);
}

/**
 * @brief Pack a mission_count_cap message on a channel
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param chan The MAVLink channel this message will be sent over
 * @param msg The MAVLink message to compress the data into
 * @param target_system  System ID
 * @param target_component  Component ID
 * @param count  Number of mission items in the sequence
 * @param mission_type  Mission type.
 * @return length of the message in bytes (excluding serial stream start sign)
 */
static inline uint16_t mavlink_msg_mission_count_cap_pack_chan(uint8_t system_id, uint8_t component_id, uint8_t chan,
                               mavlink_message_t* msg,
                                   uint8_t target_system,uint8_t target_component,uint16_t count,uint8_t mission_type)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    char buf[MAVLINK_MSG_ID_MISSION_COUNT_CAP_LEN];
    _mav_put_uint16_t(buf, 0, count);
    _mav_put_uint8_t(buf, 2, target_system);
    _mav_put_uint8_t(buf, 3, target_component);
    _mav_put_uint8_t(buf, 4, mission_type);

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), buf, MAVLINK_MSG_ID_MISSION_COUNT_CAP_LEN);
#else
    mavlink_mission_count_cap_t packet;
    packet.count = count;
    packet.target_system = target_system;
    packet.target_component = target_component;
    packet.mission_type = mission_type;

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), &packet, MAVLINK_MSG_ID_MISSION_COUNT_CAP_LEN);
#endif

    msg->msgid = MAVLINK_MSG_ID_MISSION_COUNT_CAP;
    return mavlink_finalize_message_chan(msg, system_id, component_id, chan, MAVLINK_MSG_ID_MISSION_COUNT_CAP_MIN_LEN, MAVLINK_MSG_ID_MISSION_COUNT_CAP_LEN, MAVLINK_MSG_ID_MISSION_COUNT_CAP_CRC);
}

/**
 * @brief Encode a mission_count_cap struct
 *
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param msg The MAVLink message to compress the data into
 * @param mission_count_cap C-struct to read the message contents from
 */
static inline uint16_t mavlink_msg_mission_count_cap_encode(uint8_t system_id, uint8_t component_id, mavlink_message_t* msg, const mavlink_mission_count_cap_t* mission_count_cap)
{
    return mavlink_msg_mission_count_cap_pack(system_id, component_id, msg, mission_count_cap->target_system, mission_count_cap->target_component, mission_count_cap->count, mission_count_cap->mission_type);
}

/**
 * @brief Encode a mission_count_cap struct on a channel
 *
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param chan The MAVLink channel this message will be sent over
 * @param msg The MAVLink message to compress the data into
 * @param mission_count_cap C-struct to read the message contents from
 */
static inline uint16_t mavlink_msg_mission_count_cap_encode_chan(uint8_t system_id, uint8_t component_id, uint8_t chan, mavlink_message_t* msg, const mavlink_mission_count_cap_t* mission_count_cap)
{
    return mavlink_msg_mission_count_cap_pack_chan(system_id, component_id, chan, msg, mission_count_cap->target_system, mission_count_cap->target_component, mission_count_cap->count, mission_count_cap->mission_type);
}

/**
 * @brief Send a mission_count_cap message
 * @param chan MAVLink channel to send the message
 *
 * @param target_system  System ID
 * @param target_component  Component ID
 * @param count  Number of mission items in the sequence
 * @param mission_type  Mission type.
 */
#ifdef MAVLINK_USE_CONVENIENCE_FUNCTIONS

static inline void mavlink_msg_mission_count_cap_send(mavlink_channel_t chan, uint8_t target_system, uint8_t target_component, uint16_t count, uint8_t mission_type)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    char buf[MAVLINK_MSG_ID_MISSION_COUNT_CAP_LEN];
    _mav_put_uint16_t(buf, 0, count);
    _mav_put_uint8_t(buf, 2, target_system);
    _mav_put_uint8_t(buf, 3, target_component);
    _mav_put_uint8_t(buf, 4, mission_type);

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_MISSION_COUNT_CAP, buf, MAVLINK_MSG_ID_MISSION_COUNT_CAP_MIN_LEN, MAVLINK_MSG_ID_MISSION_COUNT_CAP_LEN, MAVLINK_MSG_ID_MISSION_COUNT_CAP_CRC);
#else
    mavlink_mission_count_cap_t packet;
    packet.count = count;
    packet.target_system = target_system;
    packet.target_component = target_component;
    packet.mission_type = mission_type;

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_MISSION_COUNT_CAP, (const char *)&packet, MAVLINK_MSG_ID_MISSION_COUNT_CAP_MIN_LEN, MAVLINK_MSG_ID_MISSION_COUNT_CAP_LEN, MAVLINK_MSG_ID_MISSION_COUNT_CAP_CRC);
#endif
}

/**
 * @brief Send a mission_count_cap message
 * @param chan MAVLink channel to send the message
 * @param struct The MAVLink struct to serialize
 */
static inline void mavlink_msg_mission_count_cap_send_struct(mavlink_channel_t chan, const mavlink_mission_count_cap_t* mission_count_cap)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    mavlink_msg_mission_count_cap_send(chan, mission_count_cap->target_system, mission_count_cap->target_component, mission_count_cap->count, mission_count_cap->mission_type);
#else
    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_MISSION_COUNT_CAP, (const char *)mission_count_cap, MAVLINK_MSG_ID_MISSION_COUNT_CAP_MIN_LEN, MAVLINK_MSG_ID_MISSION_COUNT_CAP_LEN, MAVLINK_MSG_ID_MISSION_COUNT_CAP_CRC);
#endif
}

#if MAVLINK_MSG_ID_MISSION_COUNT_CAP_LEN <= MAVLINK_MAX_PAYLOAD_LEN
/*
  This variant of _send() can be used to save stack space by re-using
  memory from the receive buffer.  The caller provides a
  mavlink_message_t which is the size of a full mavlink message. This
  is usually the receive buffer for the channel, and allows a reply to an
  incoming message with minimum stack space usage.
 */
static inline void mavlink_msg_mission_count_cap_send_buf(mavlink_message_t *msgbuf, mavlink_channel_t chan,  uint8_t target_system, uint8_t target_component, uint16_t count, uint8_t mission_type)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    char *buf = (char *)msgbuf;
    _mav_put_uint16_t(buf, 0, count);
    _mav_put_uint8_t(buf, 2, target_system);
    _mav_put_uint8_t(buf, 3, target_component);
    _mav_put_uint8_t(buf, 4, mission_type);

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_MISSION_COUNT_CAP, buf, MAVLINK_MSG_ID_MISSION_COUNT_CAP_MIN_LEN, MAVLINK_MSG_ID_MISSION_COUNT_CAP_LEN, MAVLINK_MSG_ID_MISSION_COUNT_CAP_CRC);
#else
    mavlink_mission_count_cap_t *packet = (mavlink_mission_count_cap_t *)msgbuf;
    packet->count = count;
    packet->target_system = target_system;
    packet->target_component = target_component;
    packet->mission_type = mission_type;

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_MISSION_COUNT_CAP, (const char *)packet, MAVLINK_MSG_ID_MISSION_COUNT_CAP_MIN_LEN, MAVLINK_MSG_ID_MISSION_COUNT_CAP_LEN, MAVLINK_MSG_ID_MISSION_COUNT_CAP_CRC);
#endif
}
#endif

#endif

// MESSAGE MISSION_COUNT_CAP UNPACKING


/**
 * @brief Get field target_system from mission_count_cap message
 *
 * @return  System ID
 */
static inline uint8_t mavlink_msg_mission_count_cap_get_target_system(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint8_t(msg,  2);
}

/**
 * @brief Get field target_component from mission_count_cap message
 *
 * @return  Component ID
 */
static inline uint8_t mavlink_msg_mission_count_cap_get_target_component(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint8_t(msg,  3);
}

/**
 * @brief Get field count from mission_count_cap message
 *
 * @return  Number of mission items in the sequence
 */
static inline uint16_t mavlink_msg_mission_count_cap_get_count(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint16_t(msg,  0);
}

/**
 * @brief Get field mission_type from mission_count_cap message
 *
 * @return  Mission type.
 */
static inline uint8_t mavlink_msg_mission_count_cap_get_mission_type(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint8_t(msg,  4);
}

/**
 * @brief Decode a mission_count_cap message into a struct
 *
 * @param msg The message to decode
 * @param mission_count_cap C-struct to decode the message contents into
 */
static inline void mavlink_msg_mission_count_cap_decode(const mavlink_message_t* msg, mavlink_mission_count_cap_t* mission_count_cap)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    mission_count_cap->count = mavlink_msg_mission_count_cap_get_count(msg);
    mission_count_cap->target_system = mavlink_msg_mission_count_cap_get_target_system(msg);
    mission_count_cap->target_component = mavlink_msg_mission_count_cap_get_target_component(msg);
    mission_count_cap->mission_type = mavlink_msg_mission_count_cap_get_mission_type(msg);
#else
        uint8_t len = msg->len < MAVLINK_MSG_ID_MISSION_COUNT_CAP_LEN? msg->len : MAVLINK_MSG_ID_MISSION_COUNT_CAP_LEN;
        memset(mission_count_cap, 0, MAVLINK_MSG_ID_MISSION_COUNT_CAP_LEN);
    memcpy(mission_count_cap, _MAV_PAYLOAD(msg), len);
#endif
}
