// MESSAGE MISSION_HASH support class

#pragma once

namespace mavlink {
namespace common {
namespace msg {

/**
 * @brief MISSION_HASH message
 *
 * Mission hash
 */
struct MISSION_HASH : mavlink::Message {
    static constexpr msgid_t MSG_ID = 15003;
    static constexpr size_t LENGTH = 7;
    static constexpr size_t MIN_LENGTH = 7;
    static constexpr uint8_t CRC_EXTRA = 207;
    static constexpr auto NAME = "MISSION_HASH";


    uint8_t target_system; /*<  System which should execute the command */
    uint8_t target_component; /*<  Component which should execute the command, 0 for all components */
    uint8_t request; /*<  Set to 1 for request, 0 for sending the value */
    uint32_t hash; /*<  Hash value */


    inline std::string get_name(void) const override
    {
            return NAME;
    }

    inline Info get_message_info(void) const override
    {
            return { MSG_ID, LENGTH, MIN_LENGTH, CRC_EXTRA };
    }

    inline std::string to_yaml(void) const override
    {
        std::stringstream ss;

        ss << NAME << ":" << std::endl;
        ss << "  target_system: " << +target_system << std::endl;
        ss << "  target_component: " << +target_component << std::endl;
        ss << "  request: " << +request << std::endl;
        ss << "  hash: " << hash << std::endl;

        return ss.str();
    }

    inline void serialize(mavlink::MsgMap &map) const override
    {
        map.reset(MSG_ID, LENGTH);

        map << hash;                          // offset: 0
        map << target_system;                 // offset: 4
        map << target_component;              // offset: 5
        map << request;                       // offset: 6
    }

    inline void deserialize(mavlink::MsgMap &map) override
    {
        map >> hash;                          // offset: 0
        map >> target_system;                 // offset: 4
        map >> target_component;              // offset: 5
        map >> request;                       // offset: 6
    }
};

} // namespace msg
} // namespace common
} // namespace mavlink
