#pragma once
// MESSAGE MISSION_ITEM_INT_CAP PACKING

#define MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP 15005


typedef struct __mavlink_mission_item_int_cap_t {
 float param1; /*<  PARAM1, see MAV_CMD enum*/
 float param2; /*<  PARAM2, see MAV_CMD enum*/
 float param3; /*<  PARAM3, see MAV_CMD enum*/
 float param4; /*<  PARAM4, see MAV_CMD enum*/
 int32_t x; /*<  PARAM5 / local: x position in meters * 1e4, global: latitude in degrees * 10^7*/
 int32_t y; /*<  PARAM6 / y position: local: x position in meters * 1e4, global: longitude in degrees *10^7*/
 float z; /*<  PARAM7 / z position: global: altitude in meters (relative or absolute, depending on frame.*/
 uint32_t flags; /*<  Flags for special cases of mission items. Bit 0: use current altitude for the waypoint*/
 float pattern_type; /*<  Waypoint pattern (racetrack, figure of eight)*/
 float length; /*<  Length between circles*/
 float bearing; /*<  Bearing of the pattern*/
 float speed; /*<  Desired speed in waypoint*/
 uint16_t seq; /*<  Waypoint ID (sequence number). Starts at zero. Increases monotonically for each waypoint, no gaps in the sequence (0,1,2,3,4).*/
 uint16_t command; /*<  The scheduled action for the waypoint.*/
 uint8_t target_system; /*<  System ID*/
 uint8_t target_component; /*<  Component ID*/
 uint8_t frame; /*<  The coordinate system of the waypoint.*/
 uint8_t current; /*<  false:0, true:1*/
 uint8_t autocontinue; /*<  Autocontinue to next waypoint*/
 uint8_t mission_type; /*<  Mission type.*/
} mavlink_mission_item_int_cap_t;

#define MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_LEN 58
#define MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_MIN_LEN 58
#define MAVLINK_MSG_ID_15005_LEN 58
#define MAVLINK_MSG_ID_15005_MIN_LEN 58

#define MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_CRC 170
#define MAVLINK_MSG_ID_15005_CRC 170



#if MAVLINK_COMMAND_24BIT
#define MAVLINK_MESSAGE_INFO_MISSION_ITEM_INT_CAP { \
    15005, \
    "MISSION_ITEM_INT_CAP", \
    20, \
    {  { "target_system", NULL, MAVLINK_TYPE_UINT8_T, 0, 52, offsetof(mavlink_mission_item_int_cap_t, target_system) }, \
         { "target_component", NULL, MAVLINK_TYPE_UINT8_T, 0, 53, offsetof(mavlink_mission_item_int_cap_t, target_component) }, \
         { "seq", NULL, MAVLINK_TYPE_UINT16_T, 0, 48, offsetof(mavlink_mission_item_int_cap_t, seq) }, \
         { "frame", NULL, MAVLINK_TYPE_UINT8_T, 0, 54, offsetof(mavlink_mission_item_int_cap_t, frame) }, \
         { "command", NULL, MAVLINK_TYPE_UINT16_T, 0, 50, offsetof(mavlink_mission_item_int_cap_t, command) }, \
         { "current", NULL, MAVLINK_TYPE_UINT8_T, 0, 55, offsetof(mavlink_mission_item_int_cap_t, current) }, \
         { "autocontinue", NULL, MAVLINK_TYPE_UINT8_T, 0, 56, offsetof(mavlink_mission_item_int_cap_t, autocontinue) }, \
         { "param1", NULL, MAVLINK_TYPE_FLOAT, 0, 0, offsetof(mavlink_mission_item_int_cap_t, param1) }, \
         { "param2", NULL, MAVLINK_TYPE_FLOAT, 0, 4, offsetof(mavlink_mission_item_int_cap_t, param2) }, \
         { "param3", NULL, MAVLINK_TYPE_FLOAT, 0, 8, offsetof(mavlink_mission_item_int_cap_t, param3) }, \
         { "param4", NULL, MAVLINK_TYPE_FLOAT, 0, 12, offsetof(mavlink_mission_item_int_cap_t, param4) }, \
         { "x", NULL, MAVLINK_TYPE_INT32_T, 0, 16, offsetof(mavlink_mission_item_int_cap_t, x) }, \
         { "y", NULL, MAVLINK_TYPE_INT32_T, 0, 20, offsetof(mavlink_mission_item_int_cap_t, y) }, \
         { "z", NULL, MAVLINK_TYPE_FLOAT, 0, 24, offsetof(mavlink_mission_item_int_cap_t, z) }, \
         { "mission_type", NULL, MAVLINK_TYPE_UINT8_T, 0, 57, offsetof(mavlink_mission_item_int_cap_t, mission_type) }, \
         { "flags", NULL, MAVLINK_TYPE_UINT32_T, 0, 28, offsetof(mavlink_mission_item_int_cap_t, flags) }, \
         { "pattern_type", NULL, MAVLINK_TYPE_FLOAT, 0, 32, offsetof(mavlink_mission_item_int_cap_t, pattern_type) }, \
         { "length", NULL, MAVLINK_TYPE_FLOAT, 0, 36, offsetof(mavlink_mission_item_int_cap_t, length) }, \
         { "bearing", NULL, MAVLINK_TYPE_FLOAT, 0, 40, offsetof(mavlink_mission_item_int_cap_t, bearing) }, \
         { "speed", NULL, MAVLINK_TYPE_FLOAT, 0, 44, offsetof(mavlink_mission_item_int_cap_t, speed) }, \
         } \
}
#else
#define MAVLINK_MESSAGE_INFO_MISSION_ITEM_INT_CAP { \
    "MISSION_ITEM_INT_CAP", \
    20, \
    {  { "target_system", NULL, MAVLINK_TYPE_UINT8_T, 0, 52, offsetof(mavlink_mission_item_int_cap_t, target_system) }, \
         { "target_component", NULL, MAVLINK_TYPE_UINT8_T, 0, 53, offsetof(mavlink_mission_item_int_cap_t, target_component) }, \
         { "seq", NULL, MAVLINK_TYPE_UINT16_T, 0, 48, offsetof(mavlink_mission_item_int_cap_t, seq) }, \
         { "frame", NULL, MAVLINK_TYPE_UINT8_T, 0, 54, offsetof(mavlink_mission_item_int_cap_t, frame) }, \
         { "command", NULL, MAVLINK_TYPE_UINT16_T, 0, 50, offsetof(mavlink_mission_item_int_cap_t, command) }, \
         { "current", NULL, MAVLINK_TYPE_UINT8_T, 0, 55, offsetof(mavlink_mission_item_int_cap_t, current) }, \
         { "autocontinue", NULL, MAVLINK_TYPE_UINT8_T, 0, 56, offsetof(mavlink_mission_item_int_cap_t, autocontinue) }, \
         { "param1", NULL, MAVLINK_TYPE_FLOAT, 0, 0, offsetof(mavlink_mission_item_int_cap_t, param1) }, \
         { "param2", NULL, MAVLINK_TYPE_FLOAT, 0, 4, offsetof(mavlink_mission_item_int_cap_t, param2) }, \
         { "param3", NULL, MAVLINK_TYPE_FLOAT, 0, 8, offsetof(mavlink_mission_item_int_cap_t, param3) }, \
         { "param4", NULL, MAVLINK_TYPE_FLOAT, 0, 12, offsetof(mavlink_mission_item_int_cap_t, param4) }, \
         { "x", NULL, MAVLINK_TYPE_INT32_T, 0, 16, offsetof(mavlink_mission_item_int_cap_t, x) }, \
         { "y", NULL, MAVLINK_TYPE_INT32_T, 0, 20, offsetof(mavlink_mission_item_int_cap_t, y) }, \
         { "z", NULL, MAVLINK_TYPE_FLOAT, 0, 24, offsetof(mavlink_mission_item_int_cap_t, z) }, \
         { "mission_type", NULL, MAVLINK_TYPE_UINT8_T, 0, 57, offsetof(mavlink_mission_item_int_cap_t, mission_type) }, \
         { "flags", NULL, MAVLINK_TYPE_UINT32_T, 0, 28, offsetof(mavlink_mission_item_int_cap_t, flags) }, \
         { "pattern_type", NULL, MAVLINK_TYPE_FLOAT, 0, 32, offsetof(mavlink_mission_item_int_cap_t, pattern_type) }, \
         { "length", NULL, MAVLINK_TYPE_FLOAT, 0, 36, offsetof(mavlink_mission_item_int_cap_t, length) }, \
         { "bearing", NULL, MAVLINK_TYPE_FLOAT, 0, 40, offsetof(mavlink_mission_item_int_cap_t, bearing) }, \
         { "speed", NULL, MAVLINK_TYPE_FLOAT, 0, 44, offsetof(mavlink_mission_item_int_cap_t, speed) }, \
         } \
}
#endif

/**
 * @brief Pack a mission_item_int_cap message
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param msg The MAVLink message to compress the data into
 *
 * @param target_system  System ID
 * @param target_component  Component ID
 * @param seq  Waypoint ID (sequence number). Starts at zero. Increases monotonically for each waypoint, no gaps in the sequence (0,1,2,3,4).
 * @param frame  The coordinate system of the waypoint.
 * @param command  The scheduled action for the waypoint.
 * @param current  false:0, true:1
 * @param autocontinue  Autocontinue to next waypoint
 * @param param1  PARAM1, see MAV_CMD enum
 * @param param2  PARAM2, see MAV_CMD enum
 * @param param3  PARAM3, see MAV_CMD enum
 * @param param4  PARAM4, see MAV_CMD enum
 * @param x  PARAM5 / local: x position in meters * 1e4, global: latitude in degrees * 10^7
 * @param y  PARAM6 / y position: local: x position in meters * 1e4, global: longitude in degrees *10^7
 * @param z  PARAM7 / z position: global: altitude in meters (relative or absolute, depending on frame.
 * @param mission_type  Mission type.
 * @param flags  Flags for special cases of mission items. Bit 0: use current altitude for the waypoint
 * @param pattern_type  Waypoint pattern (racetrack, figure of eight)
 * @param length  Length between circles
 * @param bearing  Bearing of the pattern
 * @param speed  Desired speed in waypoint
 * @return length of the message in bytes (excluding serial stream start sign)
 */
static inline uint16_t mavlink_msg_mission_item_int_cap_pack(uint8_t system_id, uint8_t component_id, mavlink_message_t* msg,
                               uint8_t target_system, uint8_t target_component, uint16_t seq, uint8_t frame, uint16_t command, uint8_t current, uint8_t autocontinue, float param1, float param2, float param3, float param4, int32_t x, int32_t y, float z, uint8_t mission_type, uint32_t flags, float pattern_type, float length, float bearing, float speed)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    char buf[MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_LEN];
    _mav_put_float(buf, 0, param1);
    _mav_put_float(buf, 4, param2);
    _mav_put_float(buf, 8, param3);
    _mav_put_float(buf, 12, param4);
    _mav_put_int32_t(buf, 16, x);
    _mav_put_int32_t(buf, 20, y);
    _mav_put_float(buf, 24, z);
    _mav_put_uint32_t(buf, 28, flags);
    _mav_put_float(buf, 32, pattern_type);
    _mav_put_float(buf, 36, length);
    _mav_put_float(buf, 40, bearing);
    _mav_put_float(buf, 44, speed);
    _mav_put_uint16_t(buf, 48, seq);
    _mav_put_uint16_t(buf, 50, command);
    _mav_put_uint8_t(buf, 52, target_system);
    _mav_put_uint8_t(buf, 53, target_component);
    _mav_put_uint8_t(buf, 54, frame);
    _mav_put_uint8_t(buf, 55, current);
    _mav_put_uint8_t(buf, 56, autocontinue);
    _mav_put_uint8_t(buf, 57, mission_type);

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), buf, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_LEN);
#else
    mavlink_mission_item_int_cap_t packet;
    packet.param1 = param1;
    packet.param2 = param2;
    packet.param3 = param3;
    packet.param4 = param4;
    packet.x = x;
    packet.y = y;
    packet.z = z;
    packet.flags = flags;
    packet.pattern_type = pattern_type;
    packet.length = length;
    packet.bearing = bearing;
    packet.speed = speed;
    packet.seq = seq;
    packet.command = command;
    packet.target_system = target_system;
    packet.target_component = target_component;
    packet.frame = frame;
    packet.current = current;
    packet.autocontinue = autocontinue;
    packet.mission_type = mission_type;

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), &packet, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_LEN);
#endif

    msg->msgid = MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP;
    return mavlink_finalize_message(msg, system_id, component_id, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_MIN_LEN, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_LEN, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_CRC);
}

/**
 * @brief Pack a mission_item_int_cap message on a channel
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param chan The MAVLink channel this message will be sent over
 * @param msg The MAVLink message to compress the data into
 * @param target_system  System ID
 * @param target_component  Component ID
 * @param seq  Waypoint ID (sequence number). Starts at zero. Increases monotonically for each waypoint, no gaps in the sequence (0,1,2,3,4).
 * @param frame  The coordinate system of the waypoint.
 * @param command  The scheduled action for the waypoint.
 * @param current  false:0, true:1
 * @param autocontinue  Autocontinue to next waypoint
 * @param param1  PARAM1, see MAV_CMD enum
 * @param param2  PARAM2, see MAV_CMD enum
 * @param param3  PARAM3, see MAV_CMD enum
 * @param param4  PARAM4, see MAV_CMD enum
 * @param x  PARAM5 / local: x position in meters * 1e4, global: latitude in degrees * 10^7
 * @param y  PARAM6 / y position: local: x position in meters * 1e4, global: longitude in degrees *10^7
 * @param z  PARAM7 / z position: global: altitude in meters (relative or absolute, depending on frame.
 * @param mission_type  Mission type.
 * @param flags  Flags for special cases of mission items. Bit 0: use current altitude for the waypoint
 * @param pattern_type  Waypoint pattern (racetrack, figure of eight)
 * @param length  Length between circles
 * @param bearing  Bearing of the pattern
 * @param speed  Desired speed in waypoint
 * @return length of the message in bytes (excluding serial stream start sign)
 */
static inline uint16_t mavlink_msg_mission_item_int_cap_pack_chan(uint8_t system_id, uint8_t component_id, uint8_t chan,
                               mavlink_message_t* msg,
                                   uint8_t target_system,uint8_t target_component,uint16_t seq,uint8_t frame,uint16_t command,uint8_t current,uint8_t autocontinue,float param1,float param2,float param3,float param4,int32_t x,int32_t y,float z,uint8_t mission_type,uint32_t flags,float pattern_type,float length,float bearing,float speed)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    char buf[MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_LEN];
    _mav_put_float(buf, 0, param1);
    _mav_put_float(buf, 4, param2);
    _mav_put_float(buf, 8, param3);
    _mav_put_float(buf, 12, param4);
    _mav_put_int32_t(buf, 16, x);
    _mav_put_int32_t(buf, 20, y);
    _mav_put_float(buf, 24, z);
    _mav_put_uint32_t(buf, 28, flags);
    _mav_put_float(buf, 32, pattern_type);
    _mav_put_float(buf, 36, length);
    _mav_put_float(buf, 40, bearing);
    _mav_put_float(buf, 44, speed);
    _mav_put_uint16_t(buf, 48, seq);
    _mav_put_uint16_t(buf, 50, command);
    _mav_put_uint8_t(buf, 52, target_system);
    _mav_put_uint8_t(buf, 53, target_component);
    _mav_put_uint8_t(buf, 54, frame);
    _mav_put_uint8_t(buf, 55, current);
    _mav_put_uint8_t(buf, 56, autocontinue);
    _mav_put_uint8_t(buf, 57, mission_type);

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), buf, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_LEN);
#else
    mavlink_mission_item_int_cap_t packet;
    packet.param1 = param1;
    packet.param2 = param2;
    packet.param3 = param3;
    packet.param4 = param4;
    packet.x = x;
    packet.y = y;
    packet.z = z;
    packet.flags = flags;
    packet.pattern_type = pattern_type;
    packet.length = length;
    packet.bearing = bearing;
    packet.speed = speed;
    packet.seq = seq;
    packet.command = command;
    packet.target_system = target_system;
    packet.target_component = target_component;
    packet.frame = frame;
    packet.current = current;
    packet.autocontinue = autocontinue;
    packet.mission_type = mission_type;

        memcpy(_MAV_PAYLOAD_NON_CONST(msg), &packet, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_LEN);
#endif

    msg->msgid = MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP;
    return mavlink_finalize_message_chan(msg, system_id, component_id, chan, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_MIN_LEN, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_LEN, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_CRC);
}

/**
 * @brief Encode a mission_item_int_cap struct
 *
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param msg The MAVLink message to compress the data into
 * @param mission_item_int_cap C-struct to read the message contents from
 */
static inline uint16_t mavlink_msg_mission_item_int_cap_encode(uint8_t system_id, uint8_t component_id, mavlink_message_t* msg, const mavlink_mission_item_int_cap_t* mission_item_int_cap)
{
    return mavlink_msg_mission_item_int_cap_pack(system_id, component_id, msg, mission_item_int_cap->target_system, mission_item_int_cap->target_component, mission_item_int_cap->seq, mission_item_int_cap->frame, mission_item_int_cap->command, mission_item_int_cap->current, mission_item_int_cap->autocontinue, mission_item_int_cap->param1, mission_item_int_cap->param2, mission_item_int_cap->param3, mission_item_int_cap->param4, mission_item_int_cap->x, mission_item_int_cap->y, mission_item_int_cap->z, mission_item_int_cap->mission_type, mission_item_int_cap->flags, mission_item_int_cap->pattern_type, mission_item_int_cap->length, mission_item_int_cap->bearing, mission_item_int_cap->speed);
}

/**
 * @brief Encode a mission_item_int_cap struct on a channel
 *
 * @param system_id ID of this system
 * @param component_id ID of this component (e.g. 200 for IMU)
 * @param chan The MAVLink channel this message will be sent over
 * @param msg The MAVLink message to compress the data into
 * @param mission_item_int_cap C-struct to read the message contents from
 */
static inline uint16_t mavlink_msg_mission_item_int_cap_encode_chan(uint8_t system_id, uint8_t component_id, uint8_t chan, mavlink_message_t* msg, const mavlink_mission_item_int_cap_t* mission_item_int_cap)
{
    return mavlink_msg_mission_item_int_cap_pack_chan(system_id, component_id, chan, msg, mission_item_int_cap->target_system, mission_item_int_cap->target_component, mission_item_int_cap->seq, mission_item_int_cap->frame, mission_item_int_cap->command, mission_item_int_cap->current, mission_item_int_cap->autocontinue, mission_item_int_cap->param1, mission_item_int_cap->param2, mission_item_int_cap->param3, mission_item_int_cap->param4, mission_item_int_cap->x, mission_item_int_cap->y, mission_item_int_cap->z, mission_item_int_cap->mission_type, mission_item_int_cap->flags, mission_item_int_cap->pattern_type, mission_item_int_cap->length, mission_item_int_cap->bearing, mission_item_int_cap->speed);
}

/**
 * @brief Send a mission_item_int_cap message
 * @param chan MAVLink channel to send the message
 *
 * @param target_system  System ID
 * @param target_component  Component ID
 * @param seq  Waypoint ID (sequence number). Starts at zero. Increases monotonically for each waypoint, no gaps in the sequence (0,1,2,3,4).
 * @param frame  The coordinate system of the waypoint.
 * @param command  The scheduled action for the waypoint.
 * @param current  false:0, true:1
 * @param autocontinue  Autocontinue to next waypoint
 * @param param1  PARAM1, see MAV_CMD enum
 * @param param2  PARAM2, see MAV_CMD enum
 * @param param3  PARAM3, see MAV_CMD enum
 * @param param4  PARAM4, see MAV_CMD enum
 * @param x  PARAM5 / local: x position in meters * 1e4, global: latitude in degrees * 10^7
 * @param y  PARAM6 / y position: local: x position in meters * 1e4, global: longitude in degrees *10^7
 * @param z  PARAM7 / z position: global: altitude in meters (relative or absolute, depending on frame.
 * @param mission_type  Mission type.
 * @param flags  Flags for special cases of mission items. Bit 0: use current altitude for the waypoint
 * @param pattern_type  Waypoint pattern (racetrack, figure of eight)
 * @param length  Length between circles
 * @param bearing  Bearing of the pattern
 * @param speed  Desired speed in waypoint
 */
#ifdef MAVLINK_USE_CONVENIENCE_FUNCTIONS

static inline void mavlink_msg_mission_item_int_cap_send(mavlink_channel_t chan, uint8_t target_system, uint8_t target_component, uint16_t seq, uint8_t frame, uint16_t command, uint8_t current, uint8_t autocontinue, float param1, float param2, float param3, float param4, int32_t x, int32_t y, float z, uint8_t mission_type, uint32_t flags, float pattern_type, float length, float bearing, float speed)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    char buf[MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_LEN];
    _mav_put_float(buf, 0, param1);
    _mav_put_float(buf, 4, param2);
    _mav_put_float(buf, 8, param3);
    _mav_put_float(buf, 12, param4);
    _mav_put_int32_t(buf, 16, x);
    _mav_put_int32_t(buf, 20, y);
    _mav_put_float(buf, 24, z);
    _mav_put_uint32_t(buf, 28, flags);
    _mav_put_float(buf, 32, pattern_type);
    _mav_put_float(buf, 36, length);
    _mav_put_float(buf, 40, bearing);
    _mav_put_float(buf, 44, speed);
    _mav_put_uint16_t(buf, 48, seq);
    _mav_put_uint16_t(buf, 50, command);
    _mav_put_uint8_t(buf, 52, target_system);
    _mav_put_uint8_t(buf, 53, target_component);
    _mav_put_uint8_t(buf, 54, frame);
    _mav_put_uint8_t(buf, 55, current);
    _mav_put_uint8_t(buf, 56, autocontinue);
    _mav_put_uint8_t(buf, 57, mission_type);

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP, buf, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_MIN_LEN, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_LEN, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_CRC);
#else
    mavlink_mission_item_int_cap_t packet;
    packet.param1 = param1;
    packet.param2 = param2;
    packet.param3 = param3;
    packet.param4 = param4;
    packet.x = x;
    packet.y = y;
    packet.z = z;
    packet.flags = flags;
    packet.pattern_type = pattern_type;
    packet.length = length;
    packet.bearing = bearing;
    packet.speed = speed;
    packet.seq = seq;
    packet.command = command;
    packet.target_system = target_system;
    packet.target_component = target_component;
    packet.frame = frame;
    packet.current = current;
    packet.autocontinue = autocontinue;
    packet.mission_type = mission_type;

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP, (const char *)&packet, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_MIN_LEN, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_LEN, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_CRC);
#endif
}

/**
 * @brief Send a mission_item_int_cap message
 * @param chan MAVLink channel to send the message
 * @param struct The MAVLink struct to serialize
 */
static inline void mavlink_msg_mission_item_int_cap_send_struct(mavlink_channel_t chan, const mavlink_mission_item_int_cap_t* mission_item_int_cap)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    mavlink_msg_mission_item_int_cap_send(chan, mission_item_int_cap->target_system, mission_item_int_cap->target_component, mission_item_int_cap->seq, mission_item_int_cap->frame, mission_item_int_cap->command, mission_item_int_cap->current, mission_item_int_cap->autocontinue, mission_item_int_cap->param1, mission_item_int_cap->param2, mission_item_int_cap->param3, mission_item_int_cap->param4, mission_item_int_cap->x, mission_item_int_cap->y, mission_item_int_cap->z, mission_item_int_cap->mission_type, mission_item_int_cap->flags, mission_item_int_cap->pattern_type, mission_item_int_cap->length, mission_item_int_cap->bearing, mission_item_int_cap->speed);
#else
    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP, (const char *)mission_item_int_cap, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_MIN_LEN, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_LEN, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_CRC);
#endif
}

#if MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_LEN <= MAVLINK_MAX_PAYLOAD_LEN
/*
  This variant of _send() can be used to save stack space by re-using
  memory from the receive buffer.  The caller provides a
  mavlink_message_t which is the size of a full mavlink message. This
  is usually the receive buffer for the channel, and allows a reply to an
  incoming message with minimum stack space usage.
 */
static inline void mavlink_msg_mission_item_int_cap_send_buf(mavlink_message_t *msgbuf, mavlink_channel_t chan,  uint8_t target_system, uint8_t target_component, uint16_t seq, uint8_t frame, uint16_t command, uint8_t current, uint8_t autocontinue, float param1, float param2, float param3, float param4, int32_t x, int32_t y, float z, uint8_t mission_type, uint32_t flags, float pattern_type, float length, float bearing, float speed)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    char *buf = (char *)msgbuf;
    _mav_put_float(buf, 0, param1);
    _mav_put_float(buf, 4, param2);
    _mav_put_float(buf, 8, param3);
    _mav_put_float(buf, 12, param4);
    _mav_put_int32_t(buf, 16, x);
    _mav_put_int32_t(buf, 20, y);
    _mav_put_float(buf, 24, z);
    _mav_put_uint32_t(buf, 28, flags);
    _mav_put_float(buf, 32, pattern_type);
    _mav_put_float(buf, 36, length);
    _mav_put_float(buf, 40, bearing);
    _mav_put_float(buf, 44, speed);
    _mav_put_uint16_t(buf, 48, seq);
    _mav_put_uint16_t(buf, 50, command);
    _mav_put_uint8_t(buf, 52, target_system);
    _mav_put_uint8_t(buf, 53, target_component);
    _mav_put_uint8_t(buf, 54, frame);
    _mav_put_uint8_t(buf, 55, current);
    _mav_put_uint8_t(buf, 56, autocontinue);
    _mav_put_uint8_t(buf, 57, mission_type);

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP, buf, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_MIN_LEN, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_LEN, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_CRC);
#else
    mavlink_mission_item_int_cap_t *packet = (mavlink_mission_item_int_cap_t *)msgbuf;
    packet->param1 = param1;
    packet->param2 = param2;
    packet->param3 = param3;
    packet->param4 = param4;
    packet->x = x;
    packet->y = y;
    packet->z = z;
    packet->flags = flags;
    packet->pattern_type = pattern_type;
    packet->length = length;
    packet->bearing = bearing;
    packet->speed = speed;
    packet->seq = seq;
    packet->command = command;
    packet->target_system = target_system;
    packet->target_component = target_component;
    packet->frame = frame;
    packet->current = current;
    packet->autocontinue = autocontinue;
    packet->mission_type = mission_type;

    _mav_finalize_message_chan_send(chan, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP, (const char *)packet, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_MIN_LEN, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_LEN, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_CRC);
#endif
}
#endif

#endif

// MESSAGE MISSION_ITEM_INT_CAP UNPACKING


/**
 * @brief Get field target_system from mission_item_int_cap message
 *
 * @return  System ID
 */
static inline uint8_t mavlink_msg_mission_item_int_cap_get_target_system(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint8_t(msg,  52);
}

/**
 * @brief Get field target_component from mission_item_int_cap message
 *
 * @return  Component ID
 */
static inline uint8_t mavlink_msg_mission_item_int_cap_get_target_component(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint8_t(msg,  53);
}

/**
 * @brief Get field seq from mission_item_int_cap message
 *
 * @return  Waypoint ID (sequence number). Starts at zero. Increases monotonically for each waypoint, no gaps in the sequence (0,1,2,3,4).
 */
static inline uint16_t mavlink_msg_mission_item_int_cap_get_seq(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint16_t(msg,  48);
}

/**
 * @brief Get field frame from mission_item_int_cap message
 *
 * @return  The coordinate system of the waypoint.
 */
static inline uint8_t mavlink_msg_mission_item_int_cap_get_frame(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint8_t(msg,  54);
}

/**
 * @brief Get field command from mission_item_int_cap message
 *
 * @return  The scheduled action for the waypoint.
 */
static inline uint16_t mavlink_msg_mission_item_int_cap_get_command(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint16_t(msg,  50);
}

/**
 * @brief Get field current from mission_item_int_cap message
 *
 * @return  false:0, true:1
 */
static inline uint8_t mavlink_msg_mission_item_int_cap_get_current(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint8_t(msg,  55);
}

/**
 * @brief Get field autocontinue from mission_item_int_cap message
 *
 * @return  Autocontinue to next waypoint
 */
static inline uint8_t mavlink_msg_mission_item_int_cap_get_autocontinue(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint8_t(msg,  56);
}

/**
 * @brief Get field param1 from mission_item_int_cap message
 *
 * @return  PARAM1, see MAV_CMD enum
 */
static inline float mavlink_msg_mission_item_int_cap_get_param1(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  0);
}

/**
 * @brief Get field param2 from mission_item_int_cap message
 *
 * @return  PARAM2, see MAV_CMD enum
 */
static inline float mavlink_msg_mission_item_int_cap_get_param2(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  4);
}

/**
 * @brief Get field param3 from mission_item_int_cap message
 *
 * @return  PARAM3, see MAV_CMD enum
 */
static inline float mavlink_msg_mission_item_int_cap_get_param3(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  8);
}

/**
 * @brief Get field param4 from mission_item_int_cap message
 *
 * @return  PARAM4, see MAV_CMD enum
 */
static inline float mavlink_msg_mission_item_int_cap_get_param4(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  12);
}

/**
 * @brief Get field x from mission_item_int_cap message
 *
 * @return  PARAM5 / local: x position in meters * 1e4, global: latitude in degrees * 10^7
 */
static inline int32_t mavlink_msg_mission_item_int_cap_get_x(const mavlink_message_t* msg)
{
    return _MAV_RETURN_int32_t(msg,  16);
}

/**
 * @brief Get field y from mission_item_int_cap message
 *
 * @return  PARAM6 / y position: local: x position in meters * 1e4, global: longitude in degrees *10^7
 */
static inline int32_t mavlink_msg_mission_item_int_cap_get_y(const mavlink_message_t* msg)
{
    return _MAV_RETURN_int32_t(msg,  20);
}

/**
 * @brief Get field z from mission_item_int_cap message
 *
 * @return  PARAM7 / z position: global: altitude in meters (relative or absolute, depending on frame.
 */
static inline float mavlink_msg_mission_item_int_cap_get_z(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  24);
}

/**
 * @brief Get field mission_type from mission_item_int_cap message
 *
 * @return  Mission type.
 */
static inline uint8_t mavlink_msg_mission_item_int_cap_get_mission_type(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint8_t(msg,  57);
}

/**
 * @brief Get field flags from mission_item_int_cap message
 *
 * @return  Flags for special cases of mission items. Bit 0: use current altitude for the waypoint
 */
static inline uint32_t mavlink_msg_mission_item_int_cap_get_flags(const mavlink_message_t* msg)
{
    return _MAV_RETURN_uint32_t(msg,  28);
}

/**
 * @brief Get field pattern_type from mission_item_int_cap message
 *
 * @return  Waypoint pattern (racetrack, figure of eight)
 */
static inline float mavlink_msg_mission_item_int_cap_get_pattern_type(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  32);
}

/**
 * @brief Get field length from mission_item_int_cap message
 *
 * @return  Length between circles
 */
static inline float mavlink_msg_mission_item_int_cap_get_length(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  36);
}

/**
 * @brief Get field bearing from mission_item_int_cap message
 *
 * @return  Bearing of the pattern
 */
static inline float mavlink_msg_mission_item_int_cap_get_bearing(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  40);
}

/**
 * @brief Get field speed from mission_item_int_cap message
 *
 * @return  Desired speed in waypoint
 */
static inline float mavlink_msg_mission_item_int_cap_get_speed(const mavlink_message_t* msg)
{
    return _MAV_RETURN_float(msg,  44);
}

/**
 * @brief Decode a mission_item_int_cap message into a struct
 *
 * @param msg The message to decode
 * @param mission_item_int_cap C-struct to decode the message contents into
 */
static inline void mavlink_msg_mission_item_int_cap_decode(const mavlink_message_t* msg, mavlink_mission_item_int_cap_t* mission_item_int_cap)
{
#if MAVLINK_NEED_BYTE_SWAP || !MAVLINK_ALIGNED_FIELDS
    mission_item_int_cap->param1 = mavlink_msg_mission_item_int_cap_get_param1(msg);
    mission_item_int_cap->param2 = mavlink_msg_mission_item_int_cap_get_param2(msg);
    mission_item_int_cap->param3 = mavlink_msg_mission_item_int_cap_get_param3(msg);
    mission_item_int_cap->param4 = mavlink_msg_mission_item_int_cap_get_param4(msg);
    mission_item_int_cap->x = mavlink_msg_mission_item_int_cap_get_x(msg);
    mission_item_int_cap->y = mavlink_msg_mission_item_int_cap_get_y(msg);
    mission_item_int_cap->z = mavlink_msg_mission_item_int_cap_get_z(msg);
    mission_item_int_cap->flags = mavlink_msg_mission_item_int_cap_get_flags(msg);
    mission_item_int_cap->pattern_type = mavlink_msg_mission_item_int_cap_get_pattern_type(msg);
    mission_item_int_cap->length = mavlink_msg_mission_item_int_cap_get_length(msg);
    mission_item_int_cap->bearing = mavlink_msg_mission_item_int_cap_get_bearing(msg);
    mission_item_int_cap->speed = mavlink_msg_mission_item_int_cap_get_speed(msg);
    mission_item_int_cap->seq = mavlink_msg_mission_item_int_cap_get_seq(msg);
    mission_item_int_cap->command = mavlink_msg_mission_item_int_cap_get_command(msg);
    mission_item_int_cap->target_system = mavlink_msg_mission_item_int_cap_get_target_system(msg);
    mission_item_int_cap->target_component = mavlink_msg_mission_item_int_cap_get_target_component(msg);
    mission_item_int_cap->frame = mavlink_msg_mission_item_int_cap_get_frame(msg);
    mission_item_int_cap->current = mavlink_msg_mission_item_int_cap_get_current(msg);
    mission_item_int_cap->autocontinue = mavlink_msg_mission_item_int_cap_get_autocontinue(msg);
    mission_item_int_cap->mission_type = mavlink_msg_mission_item_int_cap_get_mission_type(msg);
#else
        uint8_t len = msg->len < MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_LEN? msg->len : MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_LEN;
        memset(mission_item_int_cap, 0, MAVLINK_MSG_ID_MISSION_ITEM_INT_CAP_LEN);
    memcpy(mission_item_int_cap, _MAV_PAYLOAD(msg), len);
#endif
}
